import { InputValidationError, NetworkError, ProcessedApolloError, ServerError, UnauthorizedError, UserInputError, ValidationRuleViolation } from './types';
export interface ApolloErrorHandlerResultInterface {
    allErrors: ProcessedApolloError[];
    validationRuleViolations?: ValidationRuleViolation[];
}
export declare class ApolloErrorHandlerResult implements ApolloErrorHandlerResultInterface {
    readonly unhandledErrors: ProcessedApolloError[];
    readonly handledErrors: ProcessedApolloError[];
    readonly allErrors: ProcessedApolloError[];
    constructor(unhandledErrors: ProcessedApolloError[], handledErrors: ProcessedApolloError[]);
    get networkErrors(): NetworkError[];
    get serverErrors(): ServerError[];
    get unauthorizedErrors(): UnauthorizedError[];
    get userInputErrors(): UserInputError[];
    get inputValidationErrors(): InputValidationError[];
    get validationRuleViolations(): ValidationRuleViolation[];
}
