import { ApolloError, OperationVariables } from 'apollo-client';
import { DocumentNode } from 'graphql';
import { VueApolloQueryDefinition } from 'vue-apollo/types/options';
import { Vue } from 'vue/types/vue';
import { ApolloOperationErrorHandlerFunction } from './error';
import { OverrideAllThis, SubscribeToMoreOptionsPatched } from './types';
export interface VueApolloQueryDefinitionPatched<TComponent extends Vue = Vue, TResult = any, TVariables = any> extends OverrideAllThis<Omit<VueApolloQueryDefinition<TResult, TVariables>, 'subscribeToMore' | 'variables' | 'loadingKey'>, TComponent> {
    variables?: ((this: TComponent) => TVariables) | TVariables;
    subscribeToMore?: SubscribeToMoreOptionsPatched<TComponent, TResult, TVariables> | Array<SubscribeToMoreOptionsPatched<TComponent, TResult, TVariables>>;
    loadingKey?: keyof TComponent;
    throttle?: number;
    debounce?: number;
}
export declare type VueApolloSmartQueryErrorHandler<TResult = any, TVariables = OperationVariables, TError = ApolloError, TComponent extends Vue = Vue> = (error: TError, vm: TComponent, key: string, type: 'query', options: VueApolloSmartQueryOptions<TResult, TVariables, TError, TComponent>) => void;
export declare type VueApolloSmartQueryOptions<TResult = any, TVariables = OperationVariables, TError = ApolloError, TComponent extends Vue = Vue> = VueApolloQueryDefinitionPatched<TComponent, TResult, TVariables> & {
    error?: VueApolloSmartQueryErrorHandler<TResult, TVariables, TError, TComponent>;
};
export declare type VueApolloSmartQueryOptionsFunction<TResult, TVariables, TError = ApolloError, TApp extends Vue = Vue> = <TComponent extends Vue = TApp>(options?: Partial<Omit<VueApolloSmartQueryOptions<TResult, TVariables, TError, TComponent>, 'query'>>) => VueApolloSmartQueryOptions<TResult, TVariables, TError, TComponent>;
export declare function createSmartQueryOptionsFunction<TResult, TVariables, TError = ApolloError, TApp extends Vue = Vue>(query: DocumentNode, onError?: ApolloOperationErrorHandlerFunction<TError, TApp>): VueApolloSmartQueryOptionsFunction<TResult, TVariables>;
